| Flutter Impeller |

Public Member Functions | List of all members
impeller::RectGeometry Class Reference

`#include <rect_geometry.h>`

Inheritance diagram for impeller::RectGeometry:

## Public Member Functions
| RectGeometry (Rect rect)
| ~RectGeometry ()
bool | CoversArea (const Matrix &transform, const Rect &rect) const override
| Determines if this geometry, transformed by the given `transform`, will completely cover all surface area of the given `rect`. More...
Public Member Functions inherited from impeller::Geometry
| Geometry ()
virtual | ~Geometry ()

## Additional Inherited Members
Static Public Member Functions inherited from impeller::Geometry
static std::unique_ptr< Geometry > | MakeFillPath (const Path &path, std::optional< Rect > inner_rect=std::nullopt)
static std::unique_ptr< Geometry > | MakeStrokePath (const Path &path, Scalar stroke_width=0.0, Scalar miter_limit=4.0, Cap stroke_cap=Cap::kButt, Join stroke_join=Join::kMiter)
static std::unique_ptr< Geometry > | MakeCover ()
static std::unique_ptr< Geometry > | MakeRect (Rect rect)
static std::unique_ptr< Geometry > | MakePointField (std::vector< Point > points, Scalar radius, bool round)

## Detailed Description

Definition at line 11 of file rect_geometry.h.

## Constructor & Destructor Documentation

## ◆ RectGeometry()

impeller::RectGeometry::RectGeometry | ( | Rect | rect | ) |
| explicit

Definition at line 9 of file rect_geometry.cc.

9 : rect_(rect) {}

## ◆ ~RectGeometry()

impeller::RectGeometry::~RectGeometry | ( |  | ) |
| default

## Member Function Documentation

## ◆ CoversArea()

bool impeller::RectGeometry::CoversArea | ( | const Matrix & | transform,
|  | const Rect & | rect
| ) |  | const
| override virtual

Determines if this geometry, transformed by the given `transform`, will completely cover all surface area of the given `rect`.

This is a conservative estimate useful for certain optimizations.

Returns
  `true` if the transformed geometry is guaranteed to cover the given `rect`. May return `false` in many undetected cases where the transformed geometry does in fact cover the `rect`.

Reimplemented from impeller::Geometry.

Definition at line 50 of file rect_geometry.cc.

50 {
51 if (!transform.IsTranslationScaleOnly()) {
52 return false;
53 }
54 Rect coverage = rect_.TransformBounds(transform);
55 return coverage.Contains(rect);
56 }

References impeller::TRect< T >::Contains(), impeller::Matrix::IsTranslationScaleOnly(), and impeller::TRect< T >::TransformBounds().

The documentation for this class was generated from the following files:

- impeller/entity/geometry/rect_geometry.h
- impeller/entity/geometry/rect_geometry.cc

impeller::TRect::TransformBounds
constexpr TRect TransformBounds(const Matrix &transform) const
Creates a new bounding box that contains this transformed rectangle.
Definition: rect.h:204
impeller::Rect
TRect< Scalar > Rect
Definition: rect.h:306
impeller::TRect::Contains
constexpr bool Contains(const TPoint< Type > &p) const
Definition: rect.h:122